#!/usr/bin/python
from util import *
import sys
import os
import cPickle

def loadC(data):
    t = []
    A = []
    g = []

    with open(data, 'r') as f:
        f.readline()

        for line in f:
            s = line.split(' ')
            t.append(float(s[0]))
            A.append(float(s[1]))
            g.append(float(s[2]))

    return (t, A, g)

def compare(c_data = 'fast_circ_comp/test', py_data = 'data/small-window'):
    with open(py_data, 'r') as f:
        py = cPickle.load(f)

    pt, pA, pg = py['x'], py['y4'], py['y5']
    ct, cA, cg = loadC(c_data)

    Adiff = [pa - ca for pa, ca in zip(pA, cA)]
    gdiff = [p - c for p, c in zip(pg, cg)]

    regular_plot([(pt, Adiff), (pt, gdiff)],
                 [['Adiff'], ['gdiff']],
                 [''],
                 [''],
                 [''],
                 'py-c-diffs.pdf',
                 None)

def plotPoints(data, out, diffout = None):
    t, A, g = loadC(data)

    A2 = [y * (x**-0.25 if x else 0) for x, y in zip(t,A)]

    fst, lst = t[0], t[-1]

    # regular_plot([(t, g)],
    #              [],
    #              ['$t$'],
    #              ['$g(\sqrt{t})$'],
    #              [''],
    #              'g.pdf',
    #              ((fst,-2), (lst,2)))

    regular_plot([(t, A2)],
                 [],
                 ['$t$'],
                 ['$t^{1/4} A(t)$'],
                 [''],
                 'A2.pdf',
                 ((fst,-0.5), (lst,0.5)))

    if diffout:
        diff = [x-y for x,y in zip(A,g)]
        sq_diff = [sqrt(_t)*(x-y) for _t,x,y in zip(t,A,g)]

        regular_plot([(t, diff)],
                     [],
                     ['$t$'],
                     ['$t^{1/4} A(t) - g(\sqrt{t})$'],
                     [''],
                     'tmp1.pdf',
                     ((0,-0.5),(10000,0.5)))

        regular_plot([(t, sq_diff)],
                     [],
                     ['$t$'],
                     ['$\sqrt{t}(t^{1/4} A(t) - g(\sqrt{t}))$'],
                     [''],
                     'tmp2.pdf',
                     ((0,-3),(10000,3)))

        # collate(['tmp1.pdf', 'tmp2.pdf'], diffout)
        # os.system('rm tmp1.pdf tmp2.pdf')

if __name__ == '__main__':
    if len(sys.argv) < 4:
        print 'Usage: R step pdf-path'
        sys.exit()

    R = sys.argv[1]
    step = sys.argv[2]
    path = sys.argv[3]
    data = 'data/Cellipse'
    os.system('fast_circ_comp/circ_comp %s %s %s' % (R, step, data))
    plotPoints(data, path, path[:-4] + '-diff.pdf')
