import cPickle
from circ_comp import *

def tilde_exp(R, step, out_path):
    upper = 2*pi*R*R
    x = linspace(int(upper/step), 1, upper)
    dx = [D(t) for t in x]

    hatY = [pdx/(2*sqrt(2*pi)) for pdx in prefix_average(dx)]

    sdx = [dy/sqrt(t) for t, dy in zip(x,dx)]
    tildeY = [0.5*R*pdy for pdy in prefix_average(sdx)]

    sx = [sqrt(t/(2*pi)) for t in x]

    out = (sx, hatY, tildeY)

    with open(out_path, 'w') as f:
        cPickle.dump(out, f)

def tilde_plot(data):
    with open(data, 'r') as f:
        (sx, hatY, tildeY) = cPickle.load(f)

    diff = [h - t for h, t in zip(hatY, tildeY)]

    bounds = ((0,-0.5),(100,0.5))

    regular_plot([(sx, hatY)],
                 [],
                 ['$t$'],
                 ['$A(2\pi t^2)/2\sqrt{2\pi}$'],
                 [''],
                 'figs/circ-fig-9.pdf',
                 bounds)

    regular_plot([(sx, tildeY)],
                 [],
                 ['$t$'],
                 [r'$\tilde A(t)$'],
                 [''],
                 'figs/circ-fig-8.pdf',
                 bounds)

    regular_plot([(sx, diff)],
                 [],
                 ['$t$'],
                 [r'$A(2\pi t^2)/2\sqrt{2\pi} - \tilde A(t)$'],
                 [''],
                 'figs/circ-fig-10.pdf',
                 ((0,-2),(100,2)))


if __name__ == '__main__':
    tilde_exp(100, 0.1, 'data/tilde')
    tilde_plot('data/tilde')
