#!/usr/bin/python
from circ_comp import *
from util import regular_plot, collate
import os
import cPickle

def window_compute(step = 1, upper = 10000, data = 'data/window2'):
    x4, y40 = A(upper, step)
    print 'completed A'
    y4 = [ar * sqrt(sqrt(t)) for t, ar in zip(x4, y40)]

    # x5 = linspace(int(upper/step), 1, upper)
    # x5 = x4
    y5 = [g2(sqrt(t), n_bound = 10) for t in x4]

    datum = {'x'           : x4,
             'y4'          : y4,
             'y5'          : y5,
             'upper'       : upper}

    print 'completed g'

    f = open(data, 'w')
    cPickle.dump(datum, f)
    f.close()

def window_present(window_size = 1000, data = 'data/window2',
                   folder = 'figs/windowed_small/', out = 'figs/windowed2.pdf'):
    f = open(data, 'r')
    datum = cPickle.load(f)
    f.close()

    x = datum['x']
    y4 = datum['y4']
    y5 = datum['y5']
    upper = datum['upper']

    pdfs = [folder + '%d.pdf' % i for i in range(upper/window_size)]

    for i, f in enumerate(pdfs):
        print i
        regular_plot([(x,y4), (x,y5)],
                     [['$t^{1/4}A(t)$'], ['$g(\sqrt{t})$']],
                     ['$t$'],
                     [''],
                     [],
                     f,
                     ((window_size*i, -2), (window_size*(i+1), 2)))

    collate(pdfs, out)

def diff_present(window_size = 1000, data = 'data/window2', folder = 'figs/diff/',
                 out = 'figs/diff2.pdf', do_sqrt = False):
    f = open(data, 'r')
    datum = cPickle.load(f)
    f.close()

    x = datum['x']
    y4 = datum['y4']
    y5 = datum['y5']
    if do_sqrt:
        y = [(a - b)*sqrt(x0) for x0, a, b in zip(x, y4, y5)]
    else:
        y = [a-b for a, b in zip(y4, y5)]

    upper = datum['upper']
    label = ['$\sqrt{t}(t^{1/4}A(t) - g(\sqrt{t}))$'] if do_sqrt else \
        ['$t^{1/4}A(t) - g(\sqrt{t})$']

    regular_plot([(x,y)],
                 [],
                 ['$t$'],
                 label,
                 [],
                 out,
                 ((0, -0.5), (upper, 0.5))
                 )

    # pdfs = [folder + '%d.pdf' % i for i in range(upper/window_size)]
    # for i, f in enumerate(pdfs):
    #     print i
    #     regular_plot([(x,y)],
    #                  [],
    #                  ['$t$'],
    #                  ['$t^{1/4}A(t) - g(\sqrt{t})$'],
    #                  [],
    #                  f,
    #                  ((window_size*i, -2), (window_size*(i+1), 2)))

    # collate(pdfs, 'figs/diff.pdf')

if __name__ == '__main__':
    window_compute()

    window_present()
    diff_present()

    # diff_present(do_sqrt = True, out = 'figs/entire-diff-sqrt.pdf')

    # window_compute(step = 0.1, upper = 10000, data = 'data/small-window')
    # window_present(window_size = 100, data = 'data/small-window',
    #                folder = 'figs/windowed/', out = 'figs/small-windowed.pdf')
